package com.qihoo360.apullsdk.apull.view.impl

import android.content.Context
import android.graphics.Color
import android.view.GestureDetector
import android.view.MotionEvent
import android.view.View
import com.qihoo360.apullsdk.R
import com.qihoo360.apullsdk.apull.ApullConst
import com.qihoo360.apullsdk.apull.control.sync.DownloadSatusManager
import com.qihoo360.apullsdk.apull.protocol.model.ApullTemplateBase
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateApullMv
import com.qihoo360.apullsdk.apull.protocol.model.impl.mv.ApullMvItem
import com.qihoo360.apullsdk.export.ApullRewardVideoInterface
import com.qihoo360.apullsdk.export.ApullRewardVideoInterface.Companion.template2Json
import com.qihoo360.apullsdk.support.imageconfig.ImageDownloaderConfig
import com.qihoo360.apullsdk.support.imageconfig.ImageLoaderWrapper
import com.qihoo360.apullsdk.utils.BitmapUtil
import com.qihoo360.apullsdk.utils.DensityUtil
import com.qihoo360.apullsdk.utils.tryCatch
import com.qihoo360.mobilesafe.support.log.Logger
import kotlinx.android.synthetic.main.apullsdk_container_apull_reward_video_bottom.view.*

class ContainerApullMv605VideoBottom(context: Context?, template: ApullTemplateBase?, apullRewardVideoInterface: ApullRewardVideoInterface) : ContainerApullMvBase(context, template) {

     private var mApullRewardVideoInterface : ApullRewardVideoInterface = apullRewardVideoInterface


    override fun initView(template: ApullTemplateBase?) {
        inflate(context, R.layout.apullsdk_container_apull_reward_video_bottom,this)
        DownloadSatusManager.register(this)
    }

    override fun updateView(template: ApullTemplateBase?) {
        template?.apply {
            if(template is TemplateApullMv && mTemplateApullMv != template){
                visibility = View.VISIBLE
                mTemplateApullMv = template
                apullMvItem = mTemplateApullMv.defaultItem

                mAppProgressBottom.setTextColor(resources.getColor(R.color.apullsdk_common_font_color_7))
                var drawable = BitmapUtil.createSolidDrawable(context, DensityUtil.dip2px(context, 4.0f),
                        0, Color.parseColor("#12CC72"), false)
                mAppProgressBottom.setBackgroundDrawable(drawable)
                drawable = BitmapUtil.createSolidDrawable(context, DensityUtil.dip2px(context, 4.0f),
                       0,resources.getColor(R.color.apullsdk_common_bg_green_v8), true)
                mAppProgressBottom.progressDrawable = drawable
                mAppProgressBottom.setTextDimen(DensityUtil.dip2px(context, 12.0f).toFloat())

                updateText()
                updateImage()
                addClickListener()
            }
        }
    }

    private fun addClickListener() {
        this.setOnTouchListener { _, event -> mRootDector.onTouchEvent(event) }
    }

    private fun updateImage() {
        if(apullMvItem?.adm_type == 3){
            mAppIconBottom?.let {
                ImageLoaderWrapper.getInstance().displayImage(apullMvItem?.adm?._native?.logo, it,
                        ImageDownloaderConfig.getRoundedIconOptions(context))
            }
        }
    }

    private fun updateText() {
        mAppDescBottom?.text = apullMvItem?.adm?._native?.desc
        mAppTitleBottom?.text = apullMvItem?.appNameOrTitle
        updateDownloadProgress(mAppProgressBottom)
    }

    override fun onImageEnableChange(enable: Boolean) {
        updateImage()
    }

    override fun getTemplate(): ApullTemplateBase? {
        return mTemplateApullMv
    }

    override fun onThemeChanged() {
    }

    override fun updateDownloadStatus() {
        mHandler.post{
            if(apullMvItem?.status == ApullConst.STATUS_TYPE_INSTALL_FINISHED){
                if(mTemplateApullMv?.installed_reported == false){
                    mApullRewardVideoInterface.onApkInstalled(template2Json(mTemplateApullMv,context))
                }
                handleAppInstalled()
            }
            updateText()
        }
    }

    private var rootGestureListener = object : GestureDetector.OnGestureListener{
        var clickParams = ApullMvItem.GdtClickParams()
        override fun onShowPress(e: MotionEvent?) {
        }

        override fun onSingleTapUp(e: MotionEvent?): Boolean {
            Logger.d(TAG, "btnGestureListener onSingleTapUp x ==" + e?.x)
            tryCatch {
                if (e != null) {
                    clickParams.upX = e.x.toInt()
                    clickParams.upY = e.y.toInt()
                }
                clickParams.viewW = this@ContainerApullMv605VideoBottom.width
                clickParams.viewH = this@ContainerApullMv605VideoBottom.height
                if (mTemplateApullMv?.click_reported == false) {
                    mApullRewardVideoInterface.onClick2Download(template2Json(mTemplateApullMv, context))
                }
                handleDownLoadBtnClick(clickParams)
            }
            return true
        }

        override fun onDown(e: MotionEvent?): Boolean {
            Logger.d(TAG, "btnGestureListener onDown x ==" + e?.x)
            if (e != null) {
                clickParams.downX = e.x.toInt()
                clickParams.downY = e.y.toInt()
            }
            return true
        }

        override fun onFling(e1: MotionEvent?, e2: MotionEvent?, velocityX: Float, velocityY: Float): Boolean {
            return false
        }

        override fun onScroll(e1: MotionEvent?, e2: MotionEvent?, distanceX: Float, distanceY: Float): Boolean {
            return false
        }

        override fun onLongPress(e: MotionEvent?) {
        }
    }

    private var mRootDector = GestureDetector (context, rootGestureListener)
}