package com.qihoo360.apullsdk.apull.view.impl

import android.app.Activity
import android.content.Context
import android.media.MediaMetadataRetriever
import android.text.TextUtils
import android.view.View
import android.view.animation.Animation
import android.view.animation.RotateAnimation
import com.qihoo360.apullsdk.R
import com.qihoo360.apullsdk.apull.ApullConst
import com.qihoo360.apullsdk.apull.control.sync.DownloadSatusManager
import com.qihoo360.apullsdk.apull.protocol.ApullReportManager
import com.qihoo360.apullsdk.apull.protocol.model.ApullTemplateBase
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateApullTouTiao
import com.qihoo360.apullsdk.apull.protocol.network.report.ReportNetworkTouTiao
import com.qihoo360.apullsdk.export.ApullRewardVideoInterface
import com.qihoo360.apullsdk.export.ApullRewardVideoInterface.Companion.template2Json
import com.qihoo360.apullsdk.support.cache.ApullTemplateCacheUtil
import com.qihoo360.apullsdk.support.imageconfig.ImageDownloaderConfig
import com.qihoo360.apullsdk.support.imageconfig.ImageLoaderWrapper
import com.qihoo360.apullsdk.utils.tryCatch
import com.qihoo360.mobilesafe.support.log.Logger
import kotlinx.android.synthetic.main.apullsdk_container_apull_reward_video_end.view.*


class ContainerApullToutiao2607VideoEnd : ContainerApullTouTiaoBase{

     var mApullRewardVideoInterface : ApullRewardVideoInterface

    constructor(context: Context?, template: ApullTemplateBase?,apullRewardVideoInterface:ApullRewardVideoInterface) : super(context, template){
        this.mApullRewardVideoInterface = apullRewardVideoInterface
    }

    override fun initView(template: ApullTemplateBase?) {
       inflate(context, R.layout.apullsdk_container_apull_reward_video_end,this)
        DownloadSatusManager.register(this)
    }

    override fun updateView(template: ApullTemplateBase?) {
        template?.apply {
            if(template is TemplateApullTouTiao && template != mTemplateApullTouTiao){
                visibility  = View.VISIBLE
                mTemplateApullTouTiao = template
                apullTouTiaoItem = mTemplateApullTouTiao.defaultItem

                updateText()
                updateImage()
                addClickListener()
            }
        }

    }

    private fun addClickListener() {
        mBtn?.setOnClickListener {
            startAnimation()
            if(mTemplateApullTouTiao?.click_reported == false){
                mApullRewardVideoInterface.onClick2Download(template2Json(mTemplateApullTouTiao,this@ContainerApullToutiao2607VideoEnd.context))
            }
            //下载类型正在下载时，不允许取消
            if(apullTouTiaoItem?.interaction_type == 4 &&
                    (apullTouTiaoItem?.status == ApullConst.STATUS_TYPE_DOWNLOADING || apullTouTiaoItem?.status == ApullConst.STATUS_TYPE_UPDATE_PROGRESS )){
                return@setOnClickListener
            }
            handleDownLoadBtnClick()
        }
        mClose?.setOnClickListener {
            if(context is Activity){
                val activity = context as? Activity
                if(activity?.isFinishing == false){
                    activity.finish()
                    activity.overridePendingTransition(0,0)
                }
            }
        }
    }

    private fun startAnimation() {
        val rotateAnim = RotateAnimation(-5f, 5f, Animation.RELATIVE_TO_SELF, 0.5f, Animation.RELATIVE_TO_SELF, 0.5f)
        rotateAnim.duration = 100
        mBtn.startAnimation(rotateAnim)
    }

    private fun updateImage() {
        tryCatch(catchBlock = {
            Logger.handleException(it)
        }) {
            var url = apullTouTiaoItem?.icon
            if(url.isNullOrEmpty()){
                url = apullTouTiaoItem?.image?.url
            }
            setVideoBg(apullTouTiaoItem?.video?.video_url)
            mAppIcon?.let {
                ImageLoaderWrapper.getInstance().displayImage(url, it,
                        ImageDownloaderConfig.getDefaultLargeIconOptions(context), template?.rootScene
                        ?: 0,
                        template?.rootSubscene ?: 0)
            }
        }
    }

    private fun updateText() {
        mAppTitle?.text = apullTouTiaoItem?.appNameOrTitle
        mAppDesc?.text = apullTouTiaoItem?.titleOrDesc
        if (apullTouTiaoItem.interaction_type == 4) {
            if(apullTouTiaoItem?.status == ApullConst.STATUS_TYPE_DOWNLOADING
                    ||apullTouTiaoItem?.status == ApullConst.STATUS_TYPE_UPDATE_PROGRESS ){
                mBtn?.text = context.getString(R.string.apullsdk_webview_app_start_download_tips)
            }else if(apullTouTiaoItem?.status == ApullConst.STATUS_TYPE_DOWNLOAD_FINISHED
                    || apullTouTiaoItem?.status == ApullConst.STATUS_TYPE_INSTALL){
                mBtn?.text = context.getString(R.string.apullsdk_app_download_install)
            }else if(apullTouTiaoItem?.status == ApullConst.STATUS_TYPE_INSTALL_FINISHED){
                mBtn?.text = context.getString(R.string.apullsdk_app_open)
            }else{
                mBtn?.text = context.getString(R.string.apullsdk_app_download_immediately)
            }
        } else if (apullTouTiaoItem.interaction_type == 2 || apullTouTiaoItem.interaction_type == 3) {
            mBtn?.text = context.getString(R.string.apullsdk_lookinfo)
        }
    }

    private fun setVideoBg(url: String?) {
        Thread({
            if(!url.isNullOrEmpty()){
                val mmr = MediaMetadataRetriever()
                tryCatch(finalBlock = {
                    mmr.release()//释放资源
                },catchBlock = {
                    Logger.handleException(it)
                }){
                    mmr.setDataSource(url, HashMap())
                    val bitmap = mmr.frameAtTime//获取第一帧图片
                    if(bitmap != null) {
                        mHandler?.post {
                            mVideoBgImg?.setImageBitmap(bitmap)
                            mVideoBgImg?.visibility = View.VISIBLE
                        }
                    }
                }
            }
        },"cat2607").start()

    }
    override fun onImageEnableChange(enable: Boolean) {
        updateImage()
    }

    override fun getTemplate(): ApullTemplateBase? {
        return mTemplateApullTouTiao
    }

    override fun onThemeChanged() {
    }

    override fun onApkInstalled(downloadid: String, iType: Int) {
        if (!TextUtils.isEmpty(downloadid) && downloadid == mTemplateApullTouTiao?.downloadid) {
            apullTouTiaoItem?.status = ApullConst.STATUS_TYPE_INSTALL_FINISHED
            apullTouTiaoItem?.iType = iType
            if (mTemplateApullTouTiao?.installed_reported == false) {
                mTemplateApullTouTiao?.installed_reported = true
                ApullReportManager.reportApullTouTiao(context, mTemplateApullTouTiao, ReportNetworkTouTiao.REPORTTYPE.INSTALL_FINISH, 0)
                ApullReportManager.reportApullSspTouTiaoInstalled(context, mTemplateApullTouTiao)
                mApullRewardVideoInterface.onApkInstalled(template2Json(mTemplateApullTouTiao,this@ContainerApullToutiao2607VideoEnd.context))
                ApullTemplateCacheUtil.refresh(mTemplateApullTouTiao)
            }
            updateDownloadStatus()
            if (!TextUtils.isEmpty(apullTouTiaoItem?.auto_extra_info_ui) && apullTouTiaoItem?.auto_opened_in_ui == false) {
                // 刷新状态
                apullTouTiaoItem.auto_opened_in_ui = true
                ApullTemplateCacheUtil.refresh(mTemplateApullTouTiao)
                openApp(true)
            }
            Logger.d(TAG, "onApkInstalled downloadid:$downloadid")
        }
    }


    override fun updateDownloadStatus() {
        mHandler.post{
            updateText()
        }
    }


}