package com.qihoo360.mobilesafe.reward

import android.text.TextUtils
import com.qihoo360.mobilesafe.extension.tryCatch
import com.qihoo360.mobilesafe.support.log.Logger
import org.json.JSONObject
import java.util.HashMap

class RewardConfigHelper {
    companion object {
        private val mFilterUrls = HashMap<String, String>()
        private val mRewardActivateRegisterTypes = ArrayList<String>() //分阶段奖励红包即：下载激活注册奖励类红包包名
        private const val  TAG = "RewardConfigHelper"

        private var mRewardNoticeOpenType :Boolean = false

        private var mRewardNoticeTimes:Int = 0

        private var mRewardNoticeTitle = ""

        private var mRewardNoticeHead = ""

        private var mRewardNoticeContent = ""

        private var mRewardNoticeTail = ""

        private var mRewardNoticeDate = ""

        fun reloadConfig(jsonObject: JSONObject?){
            tryCatch({
                Logger.handleException(it)
            }){
                jsonObject?.apply {
                    Logger.d(TAG,jsonObject.toString())
                    val mJArrayFilterUrls = jsonObject.optJSONArray("filter_urls")
                    if (mJArrayFilterUrls != null && mJArrayFilterUrls.length() > 0) {
                        for (i in 0 until mJArrayFilterUrls.length()) {
                            val jsonObject = mJArrayFilterUrls.optJSONObject(i)
                            if (jsonObject != null) {
                                val url = jsonObject.optString("filter_url")
                                val type = jsonObject.optString("type")
                                if (!TextUtils.isEmpty(url) && !TextUtils.isEmpty(type)) {
                                    Logger.d(TAG,"type=$type and url = $url")
                                    mFilterUrls[url] = type
                                }
                            }
                        }
                    }

                    val mJArrayActivateRegisterTypes = jsonObject.optJSONArray("activate_register_reward_list")
                    if(mJArrayActivateRegisterTypes != null && mJArrayActivateRegisterTypes.length() >0){
                        for (i in 0 until mJArrayActivateRegisterTypes.length()) {
                            val jsonObject = mJArrayActivateRegisterTypes.optJSONObject(i)
                            if (jsonObject != null) {
                                val packageName = jsonObject.optString("packageName")
                                if (!TextUtils.isEmpty(packageName) ) {
                                    Logger.d(TAG,"packageName=$packageName")
                                    mRewardActivateRegisterTypes.add(packageName)
                                }
                            }
                        }
                    }
                    val mRewardNoticeObject = jsonObject.optJSONObject("reward_notice")
                    Logger.d(TAG, "mRewardNoticeObject=$mRewardNoticeObject");
                    if(mRewardNoticeObject != null){
                        mRewardNoticeOpenType = mRewardNoticeObject.optBoolean("reward_notice_open", false)
                        mRewardNoticeTimes = mRewardNoticeObject.optInt("reward_notice_times",-1)
                        mRewardNoticeTitle = mRewardNoticeObject.optString("reward_notice_title")
                        mRewardNoticeHead = mRewardNoticeObject.optString("reward_notice_head")
                        mRewardNoticeContent = mRewardNoticeObject.optString("reward_notice_content")
                        mRewardNoticeTail = mRewardNoticeObject.optString("reward_notice_tail")
                        mRewardNoticeDate = mRewardNoticeObject.optString("reward_notice_date")
                        Logger.d(TAG,"mRewardNoticeOpenType=$mRewardNoticeOpenType,mRewardNoticeTimes=$mRewardNoticeTimes," +
                                "mRewardNoticeTitle= $mRewardNoticeTitle,mRewardNoticeHead=$mRewardNoticeHead,mRewardNoticeContent=$mRewardNoticeContent" +
                                ",mRewardNoticeTail=$mRewardNoticeTail,mRewardNoticeDate=$mRewardNoticeDate")
                    }
                }?:run {
                    Logger.d(TAG,"jsonObject empty")
                }
            }
        }

        fun getUrlTypes() :HashMap<String,String>{
             return mFilterUrls
        }

        fun getActivateRegisterTypes() :ArrayList<String>{
            return mRewardActivateRegisterTypes
        }

        fun getRewardNoticeOpenType() :Boolean{
            return mRewardNoticeOpenType
        }

        fun getRewardNoticeTimes():Int {
            return mRewardNoticeTimes
        }

        fun getRewardNoticeTitle():String{
            return mRewardNoticeTitle
        }

        fun getRewardNoticeHead():String{
            return mRewardNoticeHead
        }
        fun getRewardNoticeContent():String{
            return mRewardNoticeContent
        }

        fun getRewardNoticeTail():String{
            return mRewardNoticeTail
        }

        fun getRewardNoticeDate():String{
            return mRewardNoticeDate
        }

    }
}