package com.qihoo360.mobilesafe.reward.container.app

import android.content.Context
import android.content.Intent
import android.graphics.Color
import android.util.AttributeSet
import android.view.View
import com.nostra13.universalimageloader.core.ImageLoader
import com.qihoo360.apullsdk.apull.protocol.model.ApullTemplateBase
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateApullApp
import com.qihoo360.apullsdk.apull.view.impl.ContainerApullAppBase
import com.qihoo360.apullsdk.apull.view.utils.ApullTextPatchUtil
import com.qihoo360.apullsdk.support.imageconfig.ImageDownloaderConfig
import com.qihoo360.apullsdk.utils.BitmapUtil
import com.qihoo360.apullsdk.utils.DensityUtil
import com.qihoo360.apullsdk.videoad.view.AdOperationListener
import com.qihoo360.i.Factory
import com.qihoo360.i.IPluginManager
import com.qihoo360.mobilesafe.RewardSDK
import com.qihoo360.mobilesafe.extension.setVisible
import com.qihoo360.mobilesafe.extension.tryCatch
import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.reward.ui.page.RewardTwiceActivity
import com.qihoo360.mobilesafe.reward.ui.page.RewardTwiceActivity.Companion.REWARD_TWICE_TEMPLATE
import kotlinx.android.synthetic.main.apullsdk_container_apull_app_67.view.*

class ContainerApullApp67 : ContainerApullAppBase {

    constructor(context: Context,template: ApullTemplateBase?,listener: AdOperationListener) :super(context,template,listener)

    constructor(context: Context,template: ApullTemplateBase?) :super(context,template)

    constructor(context: Context,attrs: AttributeSet) :super(context,attrs)

    constructor(context: Context,attrs: AttributeSet,defStyle : Int) :super(context,attrs,defStyle)


    override fun initView(template: ApullTemplateBase?) {
        View.inflate(context, R.layout.apullsdk_container_apull_app_67,this)
    }

    override fun updateView(template: ApullTemplateBase?) {
        if(template is TemplateApullApp && template != templateApullApp) {
            templateApullApp = template
            setVisible(true)
            templateApullApp?.app_list?.let {
                apullAppItem = templateApullApp.app_list[0]
                updateText()
                updateImage()
                updateAppearance()
                addClickListener()
            }

        }
    }

    private fun updateAppearance() {
        var drawable = BitmapUtil.createSolidDrawable(context, DensityUtil.dip2px(context, 5.0f), 0,
                Color.parseColor("#ffffff"), false)
        mRoot67.setBackgroundDrawable(drawable)
        mRoot67.isClickable = true
        drawable = BitmapUtil.createSolidDrawable(context, DensityUtil.dip2px(context, 5.0f), Color.parseColor("#f64143"),
                Color.parseColor("#00000000"), false, 1.0f)
        mAppBtn67.setBackgroundDrawable(drawable)


        drawable = BitmapUtil.createSolidDrawable(context, DensityUtil.dip2px(context, 3.0f), 0,
                Color.parseColor("#1a000000"), false)
        mAppAdTip.setBackgroundDrawable(drawable)
    }

    private fun addClickListener() {
       mRoot67?.setOnClickListener {
           onViewClick()
       }
    }

    private fun onViewClick() {
        if(apullAppItem == null)
            return
        val intent = Intent()
        intent.putExtra(REWARD_TWICE_TEMPLATE,templateApullApp?.toJsonString())
        if(RewardSDK.mIsSingleApk){
            intent.setClass(context, RewardTwiceActivity::class.java)
            context?.startActivity(intent)
            return
        }
        Factory.startActivity(context,intent,"news","com.qihoo360.mobilesafe.reward.ui.page.RewardTwiceActivity", IPluginManager.PROCESS_AUTO)
    }

    private fun updateImage() {
        tryCatch {
            var width = 0
            var height = 0
            if (mLargeView67.layoutParams != null) {
                width = mLargeView67.layoutParams.width
                height = mLargeView67.layoutParams.height
            }
            if (!apullAppItem?.large_image_url.isNullOrEmpty()) {
                ImageLoader.getInstance().displayImage(apullAppItem.large_image_url, mLargeView67,
                        ImageDownloaderConfig.getDefaultCircle2CornerFitXYIconOptions(context, DensityUtil.px2dip(context, width.toFloat()),
                                DensityUtil.px2dip(context, height.toFloat()), 5))
            }
        }
    }

    private fun updateText() {
        if(!apullAppItem?.short_desc.isNullOrEmpty()){
            mAppShortDesc67?.text = ApullTextPatchUtil.getFormatText(context,apullAppItem?.short_desc,apullAppItem?.short_desc_patch)
        }
    }

    override fun onImageEnableChange(enable: Boolean) {
        updateImage()
    }

    override fun updateStatusInUi() {
    }

}