package com.qihoo360.mobilesafe.reward.container.gdt

import android.content.Context
import android.content.Intent
import android.os.SystemClock
import android.util.AttributeSet
import android.view.View
import com.qihoo360.apullsdk.apull.protocol.model.ApullTemplateBase
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateGdtSdkRewardVideo
import com.qihoo360.apullsdk.apull.view.ApullContainerBase
import com.qihoo360.apullsdk.apull.view.ApullContainerConst
import com.qihoo360.apullsdk.export.support.NewsExportArgsUtil.*
import com.qihoo360.i.Factory
import com.qihoo360.i.IPluginManager
import com.qihoo360.mobilesafe.extension.onClick
import com.qihoo360.mobilesafe.extension.setVisible
import com.qihoo360.mobilesafe.extension.toast
import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.reward.RewardConstant
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.REWARD_AD_UNIQUE_ID
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.REWARD_SDK_TEMPLATE
import kotlinx.android.synthetic.main.apullsdk_container_apull_app_80.view.*

/**
 * 头条SDK激励视频
 */

class ContainerApullGdt2720 : ApullContainerBase {


    private var mTemplateSDKRewardVideo : TemplateGdtSdkRewardVideo? = null

    constructor(context: Context, template: ApullTemplateBase?) :super(context,template)

    constructor(context: Context, attrs: AttributeSet) :super(context,attrs)

    constructor(context: Context, attrs: AttributeSet, defStyle : Int) :super(context,attrs,defStyle)

    override fun initView(template: ApullTemplateBase?) {
        View.inflate(context, R.layout.apullsdk_container_apull_app_80, this)
    }

    override fun updateView(template: ApullTemplateBase?) {
        if(template is TemplateGdtSdkRewardVideo && template != mTemplateSDKRewardVideo ){
            mTemplateSDKRewardVideo = template
            setVisible(true)
            updateText()
            updateImage()
            addClickListener()
        }
    }

    private fun addClickListener() {
        mRoot80?.onClick {
            /**
             * 发送广播，进行try接口
             */
            val intentOne = Intent()
            intentOne.putExtra(REWARD_AD_UNIQUE_ID,mTemplateSDKRewardVideo?.uniqueid)
            intentOne.action = RewardConstant.ACTION_REWARD_TYPE_OPEN
            context.sendBroadcast(intentOne)
            val mGdtRewardVideoAd = TemplateGdtSdkRewardVideo.getTTRewardVideoAd(mTemplateSDKRewardVideo?.uniqueid)
            if(mGdtRewardVideoAd != null){
                if(!mGdtRewardVideoAd.hasShown()){
                    val delta: Long = 1000//建议给广告过期时间加个buffer，单位ms，这里采用1000ms的buffer
                    //广告展示检查3：展示广告前判断广告数据未过期
                    if (SystemClock.elapsedRealtime() < mGdtRewardVideoAd.expireTimestamp - delta) {
                        val intent = Intent()
                        intent.putExtra(KEY_SCENE, mTemplateSDKRewardVideo?.scene)
                        intent.putExtra(KEY_SUBSCENE, mTemplateSDKRewardVideo?.subscene)
                        intent.putExtra(REWARD_SDK_TEMPLATE,ApullContainerConst.TYPE_GDKSDK_REWARDVIDEO_2720)
                        intent.putExtra(REWARD_AD_UNIQUE_ID,mTemplateSDKRewardVideo?.uniqueid)
                        intent.putExtra(KEY_INITIAL_TEMPLATE,mTemplateSDKRewardVideo?.toJsonString())
                        Factory.startActivity(context, intent,
                                "news", "com.qihoo360.newssdk.page.RewardVideoActivity", IPluginManager.PROCESS_AUTO)
                    }else{
                        context.toast(context.getString(R.string.hongbao_tip_try_again))
                    }
                }else{
                    context.toast(context.getString(R.string.hongbao_tip_try_again))
                }
            }else{
                context.toast(context.getString(R.string.hongbao_tip_try_again))
            }
        }
    }

    private fun updateImage() {
        mLargeImage80?.setImageResource(R.drawable.hongbao_rewardvideo_sdk_default)
    }

    private fun updateText() {
        mAppName80?.text ="点我有惊喜"
        mRewardBtn80?.text = context.getText(R.string.get_hongbao)
    }

    override fun onThemeChanged() {
    }

    override fun onImageEnableChange(enable: Boolean) {
        updateImage()
    }

    override fun getTemplate(): ApullTemplateBase? {
        return mTemplateSDKRewardVideo
    }
}