package com.qihoo360.mobilesafe.reward.container.mv

import android.content.Context
import android.content.Intent
import android.util.AttributeSet
import android.view.GestureDetector
import android.view.MotionEvent
import android.view.View
import android.widget.Toast
import com.qihoo360.apullsdk.apull.ApullConst
import com.qihoo360.apullsdk.apull.control.sync.DownloadSatusManager
import com.qihoo360.apullsdk.apull.protocol.ApullReportManager
import com.qihoo360.apullsdk.apull.protocol.model.ApullTemplateBase
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateApullMv
import com.qihoo360.apullsdk.apull.protocol.model.impl.mv.ApullMvItem
import com.qihoo360.apullsdk.apull.view.impl.ContainerApullMvBase
import com.qihoo360.apullsdk.support.cache.ApullTemplateCacheUtil
import com.qihoo360.apullsdk.utils.NetUtil
import com.qihoo360.apullsdk.utils.PackageUtil
import com.qihoo360.apullsdk.videoad.view.AdOperationListener
import com.qihoo360.mobilesafe.authguide.service.AuthConst
import com.qihoo360.mobilesafe.extension.setVisible
import com.qihoo360.mobilesafe.extension.toast
import com.qihoo360.mobilesafe.extension.tryCatch
import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.reward.RewardConstant
import com.qihoo360.mobilesafe.reward.container.displayImage
import com.qihoo360.mobilesafe.reward.data.ApullItemWrapper
import com.qihoo360.mobilesafe.reward.data.RewardRecordManager
import com.qihoo360.mobilesafe.reward.data.RewardUtils
import com.qihoo360.mobilesafe.reward.presenter.RewardPresenter
import com.qihoo360.mobilesafe.reward.presenter.view.RewardView
import com.qihoo360.mobilesafe.reward.ui.page.RaffleBaseActivity
import com.qihoo360.mobilesafe.reward.ui.page.RaffleWebViewActivity
import com.qihoo360.mobilesafe.reward.ui.page.dialog.RewardAuthGuideDialog
import com.qihoo360.mobilesafe.reward.ui.page.dialog.RewardDownloadDialog
import com.qihoo360.mobilesafe.reward.utils.RewardCmdHandle
import com.qihoo360.mobilesafe.reward.utils.RewardCmdHandle.Companion.startActivityForResult
import com.qihoo360.mobilesafe.support.log.Logger
import com.qihoo360.mobilesafe.ui.common.dialog.CommonDialog
import kotlinx.android.synthetic.main.apullsdk_container_apull_mv_531.view.*


const val TAG = "ContainerApullMv531"

open class ContainerApullMv531 : ContainerApullMvBase{

    private var clickParams531 = ApullMvItem.GdtClickParams()

    constructor(context: Context, template: ApullTemplateBase?, listener: AdOperationListener) :super(context,template,listener)

    constructor(context: Context, template: ApullTemplateBase?) :super(context,template)

    constructor(context: Context, attrs: AttributeSet) :super(context,attrs)

    constructor(context: Context, attrs: AttributeSet, defStyle : Int) :super(context,attrs,defStyle)


    override fun initView(template: ApullTemplateBase?) {
        View.inflate(context, R.layout.apullsdk_container_apull_mv_531, this)
        // 注册下载状态监控
        DownloadSatusManager.register(this)
    }

    override fun updateView(template: ApullTemplateBase?) {
        if((template is TemplateApullMv) && template != mTemplateApullMv ){
            mTemplateApullMv = template
            setVisible(true)
            mTemplateApullMv?.mv_list?.let {
                apullMvItem = mTemplateApullMv.mv_list[0]

                this.debugColor()
                updateImage()
                updateText()
                addClickListener()
            }
        }
    }

    open fun debugColor(){
        if (Logger.bDebug()) {
            val apullItemWrapper = ApullItemWrapper(mTemplateApullMv)
            when {
                apullItemWrapper.isDownloadDeepLink() -> this.setBackgroundColor(resources.getColor(R.color.fbutton_color_orange))
                apullItemWrapper.isDownload() -> this.setBackgroundColor(resources.getColor(R.color.theme_blue))
                apullItemWrapper.isOpenDeepLink() -> this.setBackgroundColor(resources.getColor(R.color.color_ff4545))
                apullItemWrapper.isOpenTypeH5() -> this.setBackgroundColor(resources.getColor(R.color.common_bg_green))
            }
        }
    }

    open fun addClickListener() {
         mRoot531.setOnTouchListener { _, event -> mRootDector.onTouchEvent(event) }
    }

    override fun handleAdjumpClick(clickParams: ApullMvItem.GdtClickParams) {
        tryCatch {
           // clickWithTrigger {
                Logger.d(TAG,"handleAdjumpClick")
                 ApullReportManager.reportApullMvClick(context,mTemplateApullMv)
                 ApullReportManager.reportApullSspMvClick(context,mTemplateApullMv)
                 if(isOpenDeepLink()){
                    if(apullMvItem?.deeplink_pkgname.isNullOrEmpty().not()
                        && !PackageUtil.isPkgInstalled(context,apullMvItem?.deeplink_pkgname)){

                        if(apullMvItem?.interaction_object?.url.isNullOrEmpty().not()){
                            go2H5TypeReward()
                            return //return@clickWithTrigger
                        }else{
                            context.toast(context.getString(R.string.hongbao_open_app_fail))
                            Logger.d(TAG,"deepLink_pkgname != null && deepLink app not Installed && url is empty")
                        }
                    }else{
                        if(!RewardAuthGuideDialog.isPermissionOK(context,AuthConst.AUTH_CODE_USAGE_ACCESS)) {
                            Logger.d(TAG,"top app Permission fail")
                            popupAuthGuideDialog(context.getString(R.string.apullsdk_hongbao_auth_usage_access_24), AuthConst.AUTH_CODE_USAGE_ACCESS)
                            return// return@clickWithTrigger
                        }
                        Logger.d(TAG,"top app Permission success")
                        handleDeepLinkOpen()
                    }
                 }else if(apullMvItem?.interaction_type ==2
                          && apullMvItem?.interaction_object?.url.isNullOrEmpty().not()){
                    when(apullMvItem?.open_type){
                        0 or 1 ->{
                            go2H5TypeReward()
                            return //return@clickWithTrigger
                        }
                        2 ->{
                          RewardCmdHandle.openAppWithSysWebView(context,apullMvItem)
                        }
                        else ->{

                        }
                    }
                 }
            //}
        }

    }

    //红包打开类
    private fun go2H5TypeReward() {
        tryCatch {
            /**
             * 发送广播，进行try接口
             */
            val intent = Intent()
            intent.putExtra(RewardConstant.REWARD_AD_UNIQUE_ID,apullMvItem?.unique_id)
            intent.action = RewardConstant.ACTION_REWARD_TYPE_OPEN
            context.sendBroadcast(intent)

            /**
             * 跳转到红包webView
             */
            val intentType2 = Intent()
            intentType2.putExtra(RewardConstant.EXTRA_KEY_URL,apullMvItem?.interaction_object?.url)
            intentType2.putExtra(RewardConstant.REWARD_AD_UNIQUE_ID,apullMvItem?.unique_id)
            intentType2.setClass(context, RaffleWebViewActivity::class.java)
            startActivityForResult((context as? RaffleBaseActivity),"news",intentType2,RewardConstant.REWARD_OPEN_TYPE_REQUEST_CODE)

        }
    }

    override fun handleAppClick(type :CLICKTYPE, clickParams: ApullMvItem.GdtClickParams){
        tryCatch {
           // clickWithTrigger {
                Logger.d(TAG,"handleAppClick")
                if(apullMvItem?.package_name.isNullOrEmpty().not()
                        && PackageUtil.isPkgInstalled(context,apullMvItem?.package_name)){
                    if(apullMvItem?.filter_type == 0){
                        apullMvItem?.status = ApullConst.STATUS_TYPE_INSTALL_FINISHED
                    }
                }

                if(apullMvItem?.status == ApullConst.STATUS_TYPE_INSTALL_FINISHED
                        && !apullMvItem?.interaction_object?.deeplink.isNullOrEmpty()){
                    Logger.d(TAG,"handleAppClick deepLink")
                    ApullReportManager.reportApullSspMvClick(context,mTemplateApullMv)
                    ApullReportManager.reportApullMvClick(context,mTemplateApullMv)
                    if(!RewardAuthGuideDialog.isPermissionOK(context,AuthConst.AUTH_CODE_USAGE_ACCESS)) {
                        Logger.d(TAG,"top app Permission fail")

                        popupAuthGuideDialog(context.getString(R.string.apullsdk_hongbao_auth_usage_access_24), AuthConst.AUTH_CODE_USAGE_ACCESS)
                        return //return@clickWithTrigger
                    }
                    Logger.d(TAG,"top app Permission success")

                    handleDeepLinkOpen()
                    return //return@clickWithTrigger
                }
                super.handleAppClick(type, clickParams)
           // }
        }
    }

    private fun handleDeepLinkOpen() {
        ApullReportManager.reportApullSspOpened(context,mTemplateApullMv)
        val flag = RewardCmdHandle.handleDeepLink(context,apullMvItem)
        if(flag){
            Logger.d(TAG,"handleDeepLinkOpen open ok")
            RewardRecordManager.setLastRewardUniqueId(context,apullMvItem.unique_id)
            val intent = Intent()
            intent.putExtra(RewardConstant.REWARD_AD_UNIQUE_ID,apullMvItem.unique_id)
            intent.action = RewardConstant.ACTION_REWARD_TYPE_OPEN_DEEP_LINK
            context.sendBroadcast(intent)
        }else{
            RewardRecordManager.setLastRewardUniqueId(context,apullMvItem.unique_id)
            if(!RewardCmdHandle.openMvTypeApp(context,apullMvItem,mTemplateApullMv)){
                Logger.d(TAG,"handleDeepLinkOpen openMvTypeApp fail")
                context.toast(context.getString(R.string.hongbao_open_app_fail))
            }else{
                Logger.d(TAG,"handleDeepLinkOpen openMvTypeApp ok")
            }
        }
    }


    open fun updateText() {
        mAppName531?.text = apullMvItem?.appNameOrTitle

        if (apullMvItem?.status == ApullConst.STATUS_TYPE_INSTALL_FINISHED) {
            mRewardBtn531?.text = context.getText(R.string.open)
        } else {
            mRewardBtn531?.text = context.getText(R.string.get_hongbao)
        }
    }

    private fun updateImage() {
       mLargeImage531?.apply {
           val url = apullMvItem?.logo ?: apullMvItem?.imageUrl
           displayImage(url)
       }
        if(RewardUtils.RewardInfo.isActivateOrRegisterType(mTemplateApullMv)){
            mRegisterIcon?.setVisible(true)
        }
    }

    override fun onImageEnableChange(enable: Boolean) {
           updateImage()
    }

    override fun getTemplate(): ApullTemplateBase? {
        return mTemplateApullMv
    }

    override fun onThemeChanged() {

    }

    override fun updateDownloadStatus() {
        post {
            if (apullMvItem?.status == ApullConst.STATUS_TYPE_INSTALL_FINISHED && mTemplateApullMv?.installed_reported == false) {
                mTemplateApullMv.installed_reported = true
                ApullTemplateCacheUtil.refresh(mTemplateApullMv)
                ApullReportManager.reportApullMvInstalled(context, mTemplateApullMv)
                ApullReportManager.reportApullSspMvInstalled(context, mTemplateApullMv)
            }
            updateText()
        }
    }

    override fun startDownloadApp(type: CLICKTYPE?, clickParams: ApullMvItem.GdtClickParams) {
        if(context is RewardView){
            (context as? RewardView)?.showRewardDownloadDialog(
                    ApullItemWrapper(mTemplateApullMv),mDownloadListener)
        }
        RewardRecordManager.setLastRewardUniqueId(context,apullMvItem?.unique_id)
        super.startDownloadApp(type,clickParams)
    }

    fun startDownloadAppNoDialog(type: CLICKTYPE?){
        super.startDownloadApp(type,clickParams)
    }

    override fun startDownloadAppWithTips(type:CLICKTYPE, clickParams: ApullMvItem.GdtClickParams) {
        if (NetUtil.isConnected(context)) {
            if (!NetUtil.isWifiConnected(context)) {
                val title = context.getString(R.string.tips_title)
                val body = context.getString(R.string.tips_body_start_download)
                val ok = context.getString(R.string.ok)
                val cancel = context.getString(R.string.cancel)
                val dialog = CommonDialog(context,title,body)
                dialog.setBtnOk(ok) {
                    startDownloadApp(type,clickParams)
                    dialog.dismiss()

                }
                dialog.setBtnCancel(cancel){
                    dialog.dismiss()
                }
                dialog.show()

            } else {
                startDownloadApp(type,clickParams)
            }
        } else {
            Toast.makeText(context, R.string.hongbao_net_no_connect_tips, Toast.LENGTH_SHORT).show()
        }
    }

    private val mDownloadListener = object : RewardDownloadDialog.DownloadListener {

        override fun onClick() {
            apullMvItem?.apply {
                if(apullMvItem.status == ApullConst.STATUS_TYPE_DOWNLOAD_PAUSED){
                    this@ContainerApullMv531.startDownloadAppNoDialog(CLICKTYPE.TYPE_BUTTON)
                    return
                }
                handleAppClick(CLICKTYPE.TYPE_BUTTON, clickParams531)
            }
        }

        override fun onDismiss() {
            if (apullMvItem.status == ApullConst.STATUS_TYPE_DOWNLOADING ||
                    apullMvItem.status == ApullConst.STATUS_TYPE_UPDATE_PROGRESS) {
                handleAppClick(CLICKTYPE.TYPE_BUTTON, clickParams531)
            }
        }

        override fun onContinue() {
            if (apullMvItem.status == ApullConst.STATUS_TYPE_DOWNLOAD_PAUSED) {
                this@ContainerApullMv531.startDownloadAppNoDialog(CLICKTYPE.TYPE_BUTTON)
            }
        }

    }

    private fun popupAuthGuideDialog(desc:String,authCode :Int){
        tryCatch {
            Logger.d(RewardPresenter.TAG, "popupAuthGuideDialog authCode=$authCode desc=$desc  fail")
            (context as? RaffleBaseActivity)?.popupAuthGuideDialog(desc, authCode)
        }
    }

    override fun openApp(isAuto: Boolean) {
        RewardRecordManager.setLastRewardUniqueId(context,apullMvItem.unique_id)
        super.openApp(isAuto)
    }

    private fun  isOpenDeepLink():Boolean{
        return apullMvItem?.interaction_type == 2 && apullMvItem?.interaction_object?.deeplink.isNullOrEmpty().not()
    }

    private var rootGestureListener = object :GestureDetector.OnGestureListener{

        override fun onShowPress(e: MotionEvent?) {
        }

        override fun onSingleTapUp(e: MotionEvent?): Boolean {
            Logger.d(TAG, "rootGestureListener onSingleTapUp x ==" + e?.x)
            tryCatch {
                if (e != null) {
                    clickParams531.upX = e.x.toInt()
                    clickParams531.upY = e.y.toInt()
                }
                clickParams531.viewW = this@ContainerApullMv531.width
                clickParams531.viewH = this@ContainerApullMv531.height
                apullMvItem?.let {
                    when (apullMvItem.interaction_type) {
                        3 -> handleAppClick(CLICKTYPE.TYPE_BUTTON, clickParams531)
                        2 -> handleAdjumpClick(clickParams531)//打开类
                    }
                }
            }
            return true
        }

        override fun onDown(e: MotionEvent?): Boolean {
            Logger.d(TAG, "rootGestureListener onDown x ==" + e?.x)
            if (e != null) {
                clickParams531.downX = e.x.toInt()
                clickParams531.downY = e.y.toInt()
            }
            return true
        }

        override fun onFling(e1: MotionEvent?, e2: MotionEvent?, velocityX: Float, velocityY: Float): Boolean {
           return false
        }

        override fun onScroll(e1: MotionEvent?, e2: MotionEvent?, distanceX: Float, distanceY: Float): Boolean {
            return false
        }

        override fun onLongPress(e: MotionEvent?) {
        }
    }

    private var mRootDector = GestureDetector (context, rootGestureListener)
}