package com.qihoo360.mobilesafe.reward.ui

import android.annotation.SuppressLint
import android.app.Dialog
import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseAdapter
import android.widget.TextView
import com.qihoo360.mobilesafe.extension.setVisible
import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.reward.data.RewardRecordManager
import com.qihoo360.mobilesafe.reward.respository.RewardCashListResponse
import com.qihoo360.mobilesafe.ui.common.dialog.CommonDialog
import java.text.SimpleDateFormat
import java.util.*


class RewardCashListAdapter(private val mRewardRecordManager: RewardRecordManager?, private val mContext: Context,
                            dialog: CommonDialog, private val mList: List<RewardCashListResponse.RewardCashDetail>?) : BaseAdapter() {

    private val mDialog: Dialog

    val formater = SimpleDateFormat("yyyy年MM月dd日", Locale.ENGLISH)

    init {
        mDialog = dialog
    }

    override fun getCount(): Int {
        return mList?.size ?: 0
    }

    override fun getItem(position: Int): Any? {
        return if (mList == null) {
            null
        } else mList[position]
    }

    override fun getItemId(position: Int): Long {
        return position.toLong()
    }

    @SuppressLint("ViewHolder")
    override fun getView(position: Int, convertView: View?, parent: ViewGroup?): View {
        val view =  LayoutInflater.from(mContext).inflate(R.layout.reward_record_cash_list_item, null)
        val mTitle = view.findViewById(R.id.reward_record_item_title) as TextView
        val mTime = view.findViewById(R.id.reward_record_item_time) as TextView
        val mBtn = view.findViewById(R.id.reward_record_item_button) as TextView
        val rewardDetail:RewardCashListResponse.RewardCashDetail? = mList!![position]
        if (rewardDetail != null) {

            if(rewardDetail.from == RewardCashListResponse.FROM_LOCAL) {
                mBtn.setVisible(true)
                mTime.setVisible(false)
                mBtn.setOnClickListener {
                    if(mRewardRecordManager?.handleRecordOpen(rewardDetail.mRewardRecord) == true){
                        mDialog.dismiss()
                    }
                }
                mTitle.text = mContext.getString(R.string.hongbao_cash_list_normal_local_title)
            }else {
                var  title =  mContext.getString(R.string.hongbao_cash_list_normal_title,
                        (rewardDetail.amount / 100.0 ).toString())
                if (rewardDetail.type == RewardCashListResponse.ACTIVATE_REWARD) {
                    title = mContext.getString(R.string.hongbao_cash_list_activate_title,
                            (rewardDetail.amount / 100.0).toString())
                } else if (rewardDetail.type == RewardCashListResponse.REGISTER_REWARD) {
                    title = mContext.getString(R.string.hongbao_cash_list_register_title,
                            (rewardDetail.amount / 100.0).toString())
                }
                val sd = formater.format(rewardDetail.time * 1000)
                mTime.text = sd
                mTitle.text = title
            }
        }
        return view
    }
}
