package com.qihoo360.mobilesafe.reward.ui.page.dialog

import android.content.Context
import android.os.Bundle
import com.qihoo360.mobilesafe.extension.clickWithTrigger
import com.qihoo360.mobilesafe.extension.setVisible
import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.reward.RewardConfigHelper

import com.qihoo360.mobilesafe.ui.common.dialog.CommonBaseDialog
import kotlinx.android.synthetic.main.dialog_reward_new_rules.*


class RewardNewRulesDialog(context: Context,var mRuleType: Int) : CommonBaseDialog(context, R.style.apull_dialog){


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.dialog_reward_new_rules)
        if(mRuleType == 1) {

            if(RewardConfigHelper.getRewardNoticeTitle().isEmpty()){
                title.text = "关于实施360钱包用户资产保护机制的通知"
            }else{
                title.text = RewardConfigHelper.getRewardNoticeTitle()
            }
            if(RewardConfigHelper.getRewardNoticeHead().isEmpty()) {
                head.text = "尊敬的用户：\n" +
                        "您好！为进一步提升您钱包中资产的安全性，我们拟实施用户资产保护机制，具体内容如下:"
            }else{
                head.text = RewardConfigHelper.getRewardNoticeHead()
            }
            if(RewardConfigHelper.getRewardNoticeContent().isEmpty()) {
                content.text = "保护对象：自2019年7月1日00：00至2020年1月31日24：00，从未登录过360账号的用户\n" +
                        "  措施说明：临时冻结钱包中的资产\n" +
                        "  影响功能：冻结后钱包相关功能将暂停使用\n" +
                        "  冻结时间：自2020年2月10日12:00起\n" +
                        "  冻结及解冻说明：\n" +
                        "1）2019年7月1日00：00至2020年1月31日24：00期间，凡有过账户登录行为的360用户，其钱包账户将不会被冻结。\n" +
                        "2）自2020年2月10日12:00起，被冻结钱包账户如需解冻，请发送邮件至360payhelp@360.cn，或通过“360手机卫士-我-用户反馈-其他问题”联系客服申请解冻，我们的工作人员将在收到解冻申请后3个工作日内进行处理。\n由此带来的不便敬请谅解，感谢您的支持\n"
            }else{
                content.text = RewardConfigHelper.getRewardNoticeContent()
            }

            if(RewardConfigHelper.getRewardNoticeTail().isNotEmpty()){
                team.text = RewardConfigHelper.getRewardNoticeTail()
            }
            team.setVisible(true)

            tail?.setVisible(false)
            if(RewardConfigHelper.getRewardNoticeDate().isNotEmpty()){
                date.text = RewardConfigHelper.getRewardNoticeDate()
            }
        }

        setCanceledOnTouchOutside(false)
        mClose.clickWithTrigger {
            dismiss()
        }
    }
}